uk.ac.starlink.table.formats

## Class IpacTableWriter

- java.lang.Object
- - uk.ac.starlink.table.formats.DocumentedStreamStarTableWriter
  - - uk.ac.starlink.table.formats.AbstractTextTableWriter
    - - uk.ac.starlink.table.formats.IpacTableWriter

- All Implemented Interfaces:
    Documented, DocumentedIOHandler, StarTableWriter

      public class IpacTableWriter
      extends AbstractTextTableWriter

  A StarTableWriter which writes to the IPAC text format. The data format is defined at http://irsa.ipac.caltech.edu/applications/DDGEN/Doc/ipac_tbl.html.
  Since:
    20 Sep 2012

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String` | `NULL` String representation for null values.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `IpacTableWriter()` Constructor.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `docIncludesExample()` Indicates whether the serialization of some (short) example table should be added to the user documentation for this handler.
    `java.lang.String` | `formatColumnHeads(int[] colwidths, ColumnInfo[] cinfos)` Returns a string with headings for the table columns.
    `protected java.lang.String` | `formatLine(int[] colwidths, java.lang.String[] data)` Returns a line showing a row of table data.
    `protected java.lang.String` | `formatParam(java.lang.String name, java.lang.String value, java.lang.Class<?> clazz)` Returns a formatted parameter-value pair.
    `protected java.lang.String` | `formatSeparator(int[] colwidths)` Returns a decorative separator line, of the sort you might find between the column headings and the table data.
    `java.lang.String` | `formatValue(java.lang.Object val, ValueInfo info, int width)` Formats a data value for output.
    `java.lang.String` | `getFormatName()` Returns "IPAC".
    `java.lang.String` | `getMimeType()` Returns "text/plain".
    `int` | `getMinNameWidth(ColumnInfo info)` Returns the minimum width required to output the actual characters of the name for a given column.
    `java.lang.String` | `getXmlDescription()` Returns user-directed documentation in XML format.

    - ### Methods inherited from class uk.ac.starlink.table.formats.AbstractTextTableWriter

      `getEncoding, getMaximumParameterLength, getMaxWidth, getSampledRows, getWriteParameters, setEncoding, setMaximumParameterLength, setMaxWidth, setSampledRows, setWriteParameters, writeStarTable`

    - ### Methods inherited from class uk.ac.starlink.table.formats.DocumentedStreamStarTableWriter

      `getExtensions, looksLikeFile, writeStarTable`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface uk.ac.starlink.table.formats.DocumentedIOHandler

      `matchesExtension, readText, toLink`

- - ### Field Detail

    - #### NULL

          public static java.lang.String NULL

      String representation for null values.

  - ### Constructor Detail

    - #### IpacTableWriter

          public IpacTableWriter()

      Constructor.

  - ### Method Detail

    - #### getFormatName

          public java.lang.String getFormatName()

      Returns "IPAC".
      Specified by:
        `getFormatName` in interface `StarTableWriter`
      Overrides:
        `getFormatName` in class `AbstractTextTableWriter`
      Returns:
        "text"

    - #### docIncludesExample

          public boolean docIncludesExample()

      Description copied from interface: `DocumentedIOHandler`
      Indicates whether the serialization of some (short) example table should be added to the user documentation for this handler. Binary formats, or instances for which the `Documented.getXmlDescription()` method already includes some example output, should return false.
      Returns:
        true if the user documentation would benefit from the addition of an example serialization

    - #### getXmlDescription

          public java.lang.String getXmlDescription()

      Description copied from interface: `Documented`
      Returns user-directed documentation in XML format.

      The output should be a sequence of one or more <P> elements, using XHTML-like XML. Since rendering may be done in a number of contexts however, use of the full range of XHTML elements is discouraged. Where possible, the content should stick to simple markup such as the elements P, A, UL, OL, LI, DL, DT, DD EM, STRONG, I, B, CODE, TT, PRE.

      Returns:
        XML description of this object

    - #### getMimeType

          public java.lang.String getMimeType()

      Returns "text/plain".
      Specified by:
        `getMimeType` in interface `StarTableWriter`
      Overrides:
        `getMimeType` in class `AbstractTextTableWriter`
      Returns:
        MIME content type

    - #### getMinNameWidth

          public int getMinNameWidth(ColumnInfo info)

      Description copied from class: `AbstractTextTableWriter`
      Returns the minimum width required to output the actual characters of the name for a given column. Padding applied subsequently by this object's `AbstractTextTableWriter.formatColumnHeads(int[], uk.ac.starlink.table.ColumnInfo[])` method does not need to be included.
      Overrides:
        `getMinNameWidth` in class `AbstractTextTableWriter`
      Parameters:
        `info` - column metadata
      Returns:
        minimum number of characters required for column title

    - #### formatValue

          public java.lang.String formatValue(java.lang.Object val,
                                              ValueInfo info,
                                              int width)

      Description copied from class: `AbstractTextTableWriter`
      Formats a data value for output.
      Specified by:
        `formatValue` in class `AbstractTextTableWriter`
      Parameters:
        `val` - the value
        `info` - the metadata object describing `val`'s type
        `width` - maximum preferred width into which the value should be formatted
      Returns:
        formatted string meaning `value`, preferably no longer than `width` characters

    - #### formatColumnHeads

          public java.lang.String formatColumnHeads(int[] colwidths,
                                                    ColumnInfo[] cinfos)

      Description copied from class: `AbstractTextTableWriter`
      Returns a string with headings for the table columns.
      Specified by:
        `formatColumnHeads` in class `AbstractTextTableWriter`
      Parameters:
        `colwidths` - column widths in characters
        `cinfos` - array of column headings
      Returns:
        headings line including any line end characters

    - #### formatLine

          protected java.lang.String formatLine(int[] colwidths,
                                                java.lang.String[] data)

      Description copied from class: `AbstractTextTableWriter`
      Returns a line showing a row of table data.
      Specified by:
        `formatLine` in class `AbstractTextTableWriter`
      Parameters:
        `colwidths` - column widths in characters
        `data` - array of strings to be output, one per column
      Returns:
        data line including any line end characters

    - #### formatSeparator

          protected java.lang.String formatSeparator(int[] colwidths)

      Description copied from class: `AbstractTextTableWriter`
      Returns a decorative separator line, of the sort you might find between the column headings and the table data.
      Specified by:
        `formatSeparator` in class `AbstractTextTableWriter`
      Parameters:
        `colwidths` - column widths in characters
      Returns:
        separator line including any line end characters

    - #### formatParam

          protected java.lang.String formatParam(java.lang.String name,
                                                 java.lang.String value,
                                                 java.lang.Class<?> clazz)

      Description copied from class: `AbstractTextTableWriter`
      Returns a formatted parameter-value pair.
      Specified by:
        `formatParam` in class `AbstractTextTableWriter`
      Parameters:
        `name` - parameter name
        `value` - formatted parameter value
        `clazz` - type of value
      Returns:
        parameter line including any line end characters